module data.stream {
   constructor: end_of_file/0.

   input_stream = module {
      abstract: read/1.

      string(L) :-
         read(C),
         (
            C = end_of_file
         ->
            L = []
         ;
            L = [C | Tail],
            string(Tail)
         ).

      atom = data.string:atom(string).
   }.

   list(Stream) = data.list:accumulate() {
      get(X) :-
         X = Stream:read,
         X \= end_of_file,
         X \= 'end_of_file'(_). % support of positionable stream
   }
}
