module net.socket {
   inet(M) :-
      kernel:socket('AF_INET', Socket),
      module M {
         bind(Host, Port) :-
            kernel:socket_bind(Socket, 'AF_INET'(Host, Port)).

         listen(Length) :-
            kernel:socket_listen(Socket, Length).

         accept(Stream) :-
            accept(_Client, Stream).

         accept(Client, Stream) :-
            kernel:socket_accept(Socket, Client, In, Out),
            io.stream:of_kernel_in(In, Stream),
            io.stream:of_kernel_out(Out, Stream).
      }
}